<template>
  <a-row type="flex" justify="center">
    <a-col :span="24">
      <a-page-header title="Produkte"></a-page-header>
      <client-only>
        <a-list :grid="{ gutter: 16, xs: 1, sm: 2, md: 2, lg: 3, xl: 4, xxl: 4 }" :data-source="displayedProducts"
                :loading="loading"
                :locale="{ emptyText: 'Keine passenden Produkte gefunden' }">
          <a-list-item slot="renderItem" slot-scope="item, index">
            <ProductCard :product="item"></ProductCard>
          </a-list-item>
        </a-list>
      </client-only>
    </a-col>
  </a-row>
</template>

<script lang="ts">
import Vue from 'vue'
import productsQuery from '~/apollo/queries/products/products.graphql'
import ProductCard from '~/components/ProductCard.vue'
import { Product } from '~/types/types.js'

export default Vue.extend({
  components: {
    ProductCard
  },
  data () {
    return {
      products: [] as Array<Product>
    }
  },
  computed: {
    displayedProducts (): Array<Product> {
      if (!this.$route.query.category) {
        return this.products
      }
      return this.products.filter((current) => {
        return current.categories.find((cat) => {
          return cat.slug === this.$route.query.category
        })
      })
    },
    loading (): boolean {
      return this.$apollo.loading
    }
  },
  apollo: {
    products: {
      prefetch: true,
      query: productsQuery
    }
  }
})
</script>

<style lang="scss" scoped>
</style>
